
--
-- Base de datos: `trivial`
--

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `jugador`
--

CREATE TABLE IF NOT EXISTS `jugador` (
`idJugador` int(11) NOT NULL,
  `nombre` varchar(32) CHARACTER SET latin1 DEFAULT NULL,
  `correo` varchar(32) CHARACTER SET latin1 DEFAULT NULL,
  `contrasena` varchar(32) CHARACTER SET latin1 DEFAULT NULL,
  `fechaAlta` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `partidas` int(11) DEFAULT '0' COMMENT 'número de partidas comenzadas',
  `ganadas` int(11) DEFAULT '0' COMMENT 'número de partidas ganadas',
  `perdidas` int(11) DEFAULT '0' COMMENT 'número de partidas perdidas',
  `codigoGCM` varchar(255) CHARACTER SET latin1 DEFAULT NULL
) ENGINE=InnoDB AUTO_INCREMENT=38 DEFAULT CHARSET=utf8 COLLATE=utf8_spanish_ci;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `jugadoracierto`
--

CREATE TABLE IF NOT EXISTS `jugadoracierto` (
  `idJugador` int(11) DEFAULT NULL,
  `idTema` int(11) DEFAULT NULL,
  `veces` int(11) DEFAULT '0' COMMENT 'número de preguntas de un tema a un jugador',
  `aciertos` int(11) DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `partida`
--

CREATE TABLE IF NOT EXISTS `partida` (
  `idPartida` int(11) DEFAULT NULL,
  `idTablero` int(11) DEFAULT NULL,
  `idReglas` int(11) DEFAULT NULL,
  `idCreador` int(11) DEFAULT NULL,
  `fechaAlta` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `numJugadores` int(11) DEFAULT NULL,
  `estado` varchar(32) DEFAULT NULL,
  `turno` int(11) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `partidajugador`
--

CREATE TABLE IF NOT EXISTS `partidajugador` (
  `idPartida` int(11) DEFAULT NULL,
  `idJugador` int(11) DEFAULT NULL,
  `turno` int(11) DEFAULT NULL,
  `casilla` int(11) DEFAULT NULL,
  `aciertos` int(11) DEFAULT NULL,
  `tieneTema1` tinyint(4) DEFAULT NULL,
  `tieneTema2` tinyint(4) DEFAULT NULL,
  `tieneTema3` tinyint(4) DEFAULT NULL,
  `tieneTema4` tinyint(4) DEFAULT NULL,
  `tieneTema5` tinyint(4) DEFAULT NULL,
  `tieneTema6` tinyint(4) DEFAULT NULL,
  `tieneTema7` tinyint(4) DEFAULT NULL,
  `tieneTema8` tinyint(4) DEFAULT NULL,
  `tieneTema9` tinyint(4) DEFAULT NULL,
  `tieneTema10` tinyint(4) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Volcado de datos para la tabla `partidajugador`
--

INSERT INTO `partidajugador` (`idPartida`, `idJugador`, `turno`, `casilla`, `aciertos`, `tieneTema1`, `tieneTema2`, `tieneTema3`, `tieneTema4`, `tieneTema5`, `tieneTema6`, `tieneTema7`, `tieneTema8`, `tieneTema9`, `tieneTema10`) VALUES
(1, 4, 1, NULL, 6, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `pregunta`
--

CREATE TABLE IF NOT EXISTS `pregunta` (
`idPregunta` int(11) NOT NULL,
  `idTema` int(11) DEFAULT NULL,
  `texto` varchar(180) COLLATE utf8_spanish_ci DEFAULT NULL,
  `urlMedia` varchar(140) COLLATE utf8_spanish_ci DEFAULT NULL,
  `respuesta1` varchar(140) COLLATE utf8_spanish_ci DEFAULT NULL,
  `respuesta2` varchar(140) COLLATE utf8_spanish_ci DEFAULT NULL,
  `respuesta3` varchar(140) COLLATE utf8_spanish_ci DEFAULT NULL,
  `respuesta4` varchar(140) COLLATE utf8_spanish_ci DEFAULT NULL,
  `respuesta5` varchar(140) COLLATE utf8_spanish_ci DEFAULT NULL,
  `correcta` int(11) DEFAULT NULL,
  `veces` int(11) DEFAULT NULL,
  `aciertos` int(11) DEFAULT NULL
) ENGINE=InnoDB AUTO_INCREMENT=76 DEFAULT CHARSET=utf8 COLLATE=utf8_spanish_ci;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `reglas`
--

CREATE TABLE IF NOT EXISTS `reglas` (
  `idReglas` int(11) DEFAULT NULL,
  `nombre` varchar(32) DEFAULT NULL,
  `tMaxJugada` int(11) DEFAULT NULL,
  `tMaxPartida` int(11) DEFAULT NULL,
  `esperaMax` int(11) DEFAULT NULL,
  `minJugadores` int(11) DEFAULT NULL,
  `maxJugadores` int(11) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `tablero`
--

CREATE TABLE IF NOT EXISTS `tablero` (
  `idTablero` int(11) DEFAULT NULL,
  `nombre` varchar(32) DEFAULT NULL,
  `numTemas` int(11) DEFAULT NULL,
  `numCasillas` int(11) DEFAULT NULL,
  `idTema1` int(11) DEFAULT NULL,
  `colorTema1` varchar(32) DEFAULT NULL,
  `idTema2` int(11) DEFAULT NULL,
  `colorTema2` varchar(32) DEFAULT NULL,
  `idTema3` int(11) DEFAULT NULL,
  `colorTema3` varchar(32) DEFAULT NULL,
  `idTema4` int(11) DEFAULT NULL,
  `colorTema4` varchar(32) DEFAULT NULL,
  `idTema5` int(11) DEFAULT NULL,
  `colorTema5` varchar(32) DEFAULT NULL,
  `idTema6` int(11) DEFAULT NULL,
  `colorTema6` varchar(32) DEFAULT NULL,
  `idTema7` int(11) DEFAULT NULL,
  `colorTema7` varchar(32) DEFAULT NULL,
  `idTema8` int(11) DEFAULT NULL,
  `colorTema8` varchar(32) DEFAULT NULL,
  `idTema9` int(11) DEFAULT NULL,
  `colorTema9` varchar(32) DEFAULT NULL,
  `idTema10` int(11) DEFAULT NULL,
  `colorTema10` varchar(32) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `tema`
--

CREATE TABLE IF NOT EXISTS `tema` (
`idTema` int(11) NOT NULL,
  `nombre` varchar(50) COLLATE utf8_spanish_ci DEFAULT NULL,
  `imagen` varchar(64) COLLATE utf8_spanish_ci DEFAULT NULL COMMENT 'URL a imagen del tema',
  `fechaAlta` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `numPreguntas` int(11) DEFAULT '0' COMMENT 'número de preguntas en un Tema',
  `veces` int(11) DEFAULT '0' COMMENT 'número de preguntas de un tema a un jugador',
  `aciertos` int(11) DEFAULT '0'
) ENGINE=InnoDB AUTO_INCREMENT=19 DEFAULT CHARSET=utf8 COLLATE=utf8_spanish_ci;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `temaextendido`
--

CREATE TABLE IF NOT EXISTS `temaextendido` (
`idTemaExtendido` int(11) NOT NULL,
  `idTema` int(11) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Índices para tablas volcadas
--

--
-- Indices de la tabla `jugador`
--
ALTER TABLE `jugador`
 ADD PRIMARY KEY (`idJugador`);

--
-- Indices de la tabla `jugadoracierto`
--
ALTER TABLE `jugadoracierto`
 ADD KEY `idJugador` (`idJugador`), ADD KEY `idTema` (`idTema`);

--
-- Indices de la tabla `pregunta`
--
ALTER TABLE `pregunta`
 ADD PRIMARY KEY (`idPregunta`);

--
-- Indices de la tabla `tema`
--
ALTER TABLE `tema`
 ADD PRIMARY KEY (`idTema`);

--
-- Indices de la tabla `temaextendido`
--
ALTER TABLE `temaextendido`
 ADD PRIMARY KEY (`idTemaExtendido`);

--
-- AUTO_INCREMENT de las tablas volcadas
--

--
-- AUTO_INCREMENT de la tabla `jugador`
--
ALTER TABLE `jugador`
MODIFY `idJugador` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=38;
--
-- AUTO_INCREMENT de la tabla `pregunta`
--
ALTER TABLE `pregunta`
MODIFY `idPregunta` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=76;
--
-- AUTO_INCREMENT de la tabla `tema`
--
ALTER TABLE `tema`
MODIFY `idTema` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=19;
--
-- AUTO_INCREMENT de la tabla `temaextendido`
--
ALTER TABLE `temaextendido`
MODIFY `idTemaExtendido` int(11) NOT NULL AUTO_INCREMENT;
--
-- Restricciones para tablas volcadas
--

--
-- Filtros para la tabla `jugadoracierto`
--
ALTER TABLE `jugadoracierto`
ADD CONSTRAINT `jugadoracierto_ibfk_1` FOREIGN KEY (`idJugador`) REFERENCES `jugador` (`idJugador`),
ADD CONSTRAINT `jugadoracierto_ibfk_2` FOREIGN KEY (`idTema`) REFERENCES `tema` (`idTema`);

