package org.example.Trivial_UPV;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.AsyncTask;
import android.os.Bundle;
import android.text.Editable;
import android.util.Log;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.webkit.JavascriptInterface;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import com.google.android.gms.common.ConnectionResult;
import com.google.android.gms.common.GooglePlayServicesUtil;
import com.google.android.gms.gcm.GoogleCloudMessaging;

import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import static org.example.Trivial_UPV.UtilidadesGCM.A_KEY;
import static org.example.Trivial_UPV.UtilidadesGCM.SENDER_ID;
import static org.example.Trivial_UPV.UtilidadesGCM.SERVER_URL;
import static org.example.Trivial_UPV.UtilidadesGCM.actividadAbierta;
import static org.example.Trivial_UPV.UtilidadesGCM.mostrarMensaje;


public class ActividadPrincipal extends Activity {

    private static final String TAG = "ActividadPrincipal";
    EditText txtName;
    EditText txtEmail;
    EditText txtPassw;

    String idRegistro = "";
    GoogleCloudMessaging gcm;
    private final static int PLAY_SERVICES_RESOLUTION_REQUEST = 9000;

    ProgressDialog dialogo;

    final InterfazComunicacion miInterfazJava = new InterfazComunicacion(this);

     protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.menuprincipal);

        if (comprobarGooglePlayServices()) {
            mostrarMensaje(this, "Se ha encontrado un Google Play Services válido.");
        } else {
            mostrarMensaje(this, "No se ha encontrado un Google Play Services válido.");
            finish();
        }


        registrarUsuarioGCM();


        SharedPreferences prefs = getSharedPreferences("Preferencias", Context.MODE_PRIVATE);
        final String nombreJ1;
        final String nombreJ2;
        nombreJ1 = prefs.getString("jugador1", null);
        nombreJ2 = prefs.getString("jugador2", null);

        Button btn_R=(Button) findViewById(R.id.btn_registrar);//6.3.3.5

    }
    public void msjRegistWeb_p(View v) {// BOTON DE RGISTRO
        Intent i = new Intent(this, Registro.class);
        startActivity(i);
        // Close Registration View
        finish();
    }
    public void listadoOnClick(View view){
        startActivity(new Intent(this, ListadoActivity.class));
    }
    @Override
    protected void onResume() {
        super.onResume();
        actividadAbierta = true;
        comprobarGooglePlayServices();
        if (getIntent().hasExtra("mensaje")) {
            Bundle extras = getIntent().getExtras();
            String mensaje = extras.getString("mensaje");
            //mostrarMensaje(ActividadPrincipal.this, mensaje);//null puntero
            mostrarMensaje(ActividadPrincipal.this, mensaje);
            getIntent().removeExtra("mensaje");

            String funtion = extras.getString("funcion");
            Log.d("funtion",funtion);
            aceptInvitacion(getApplicationContext(), funtion);
        }
    }
    private boolean comprobarGooglePlayServices() {
        int resultCode = GooglePlayServicesUtil.isGooglePlayServicesAvailable(this);
        if (resultCode != ConnectionResult.SUCCESS) {
            if (GooglePlayServicesUtil.isUserRecoverableError(resultCode)) {
                GooglePlayServicesUtil.getErrorDialog(resultCode, this, PLAY_SERVICES_RESOLUTION_REQUEST).show();
            } else {
                //Dispositivo no soportado.
                mostrarMensaje(this, "Tienes que tener Google Play Services instalado y actualizado.");
                finish();
            }return false;
        }return true;
    }
    public void Ir(View view) {
        //navegador.loadUrl("http://cursoandroid.hol.es/appweb/index.html");
    }

    private boolean comprobarConectividad() {
        ConnectivityManager connectivityManager = (ConnectivityManager)
                this.getSystemService(Context.CONNECTIVITY_SERVICE);
        NetworkInfo info = connectivityManager.getActiveNetworkInfo();
        if ((info == null || !info.isConnected() || !info.isAvailable())) {
            Toast.makeText(ActividadPrincipal.this, "Oops! No tienes conexión a internet", Toast.LENGTH_LONG).show();
            return false;
        } return true;
    }

    public class InterfazComunicacion {
        Context mContext;

        InterfazComunicacion(Context c) {
            mContext = c;
        }

        @JavascriptInterface
        public void mensaje(String contenido) {
            Toast.makeText(mContext, contenido, Toast.LENGTH_SHORT).show();
        }
        @JavascriptInterface
        public void msjOnlineGCM() {
            registrarNotGCM tareaN = new registrarNotGCM();
            tareaN.execute(null, null, null);
        }
    }
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        super.onCreateOptionsMenu(menu);       MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.inicio, menu);                               return true;
    }
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case R.id.jugador1:
                nombreJugador("1");
                break;
            case R.id.jugador2:
                nombreJugador("2");
                break;
            case R.id.inicio:
                ////navegador.loadUrl("javascript:mostrarInicio()");
                break;
        }
        return true;
    }
    public void nombreJugador(final String jugador) {
        AlertDialog.Builder alert = new AlertDialog.Builder(ActividadPrincipal.this);
        alert.setTitle("Nombre jugador" + jugador);
        alert.setMessage("Nombre:");
        final EditText nombre = new EditText(this);
        alert.setView(nombre);
        alert.setPositiveButton("Guardar", new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog, int whichButton) {
                Editable valor = nombre.getText();
                ////navegador.loadUrl("javascript:cambiaNombreJugador(\"" + jugador + "\",\"" +valor.toString() + "\");");
                SharedPreferences prefs = getSharedPreferences("Preferencias",Context.MODE_PRIVATE);
                SharedPreferences.Editor editor = prefs.edit();
                editor.putString("jugador" + jugador, valor.toString());
                editor.commit();
            }
        });
        alert.setNegativeButton("Cancelar", new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog, int whichButton) {
            }
        });
        alert.show();
    }

    public void registrarUsuarioGCM() { //sin parametros
        idRegistro = dameIdRegistro(getApplicationContext());

        if (idRegistro.equals("")) {

            registrarGCM tareaRegistroGCM = new registrarGCM();

            tareaRegistroGCM.execute(null, null, null);

        } else {
            mostrarMensaje(this, "Dispositivo ya registrado.");
        }
    }
    public String dameIdRegistro(Context context) {
        final SharedPreferences preferencias = getSharedPreferences(
                ActividadPrincipal.class.getSimpleName(), Context.MODE_PRIVATE);
        String auxRegistroId = preferencias.getString("idRegistro", "");
        if (auxRegistroId.equals(""))           {            return "";        }
        return auxRegistroId;
    }
    private class registrarGCM extends AsyncTask<String, Integer, String> {
        private Context applicationContext;

        protected String doInBackground(String... params) {
            String msg = "";
            Boolean registroWeb = false;
            try {
                //GoogleCloudMessaging gcm;
                if (gcm == null) {
                    gcm = GoogleCloudMessaging.getInstance(getApplicationContext());
                }
                idRegistro = gcm.register(SENDER_ID);
                //registroWeb = registrarDispositivoEnServidorWeb(getApplicationContext(),idRegistro);//ojo

                //if (registroWeb == true)
                {
                    guardarIdRegistro(getApplicationContext(), idRegistro);
                    msg = "Dispositivo registrado, idRegistro=" + idRegistro;
                }
            } catch (IOException ex) {
                msg = "Error registro GCM:" + ex.getMessage();
            }
            return msg;
        }
        protected void onPostExecute(String message) {
            mostrarMensaje(getApplicationContext(), message);
        }
    }

    private void guardarIdRegistro(Context context, String regId) {
        final SharedPreferences prefs = getSharedPreferences(
                ActividadPrincipal.class.getSimpleName(), Context.MODE_PRIVATE);
        SharedPreferences.Editor editor = prefs.edit();
        editor.putString("idRegistro", regId);
        editor.commit();
    }


    private class registrarNotGCM extends AsyncTask<String, Integer, String> {

        protected String doInBackground(String... params) {
            //Boolean registroWeb = false;
            String msg = "";
            String auxIdRegistro = "";
            String nombre="miki";
            try {
                auxIdRegistro = dameIdRegistro(getApplicationContext());
                if (auxIdRegistro.equals("")) {
                    msg = "El dispositivo no está registrado";

                }
                //gcm.unregister();
               enviarNofServidorWeb( getApplicationContext(), auxIdRegistro, nombre);

                msg = "mensaje enviado";

            } catch (Exception e) {
                e.printStackTrace();
            }
return msg;
        }
        protected void onPostExecute(String message) {
            mostrarMensaje(getApplicationContext(), message);
        }
    }
    private Boolean enviarNofServidorWeb(Context context, final String regId,   String nombreJ1) {
        String serverUrl = SERVER_URL + "notificar.php";
        List<NameValuePair> params = new ArrayList<NameValuePair>();
        params.add(new BasicNameValuePair("iddevice", regId));
        params.add(new BasicNameValuePair("idapp", SENDER_ID));
        params.add(new BasicNameValuePair("apiKey", A_KEY));
        params.add(new BasicNameValuePair("mensaje", "Recibiste invitacion a jugar Trivial_UPV "));
        params.add(new BasicNameValuePair("funcion", nombreJ1)); // ojo con nombre
       //params.add(new BasicNameValuePair("funcion", "azul"));
        params.add(new BasicNameValuePair("fila", "3"));
       // params.add(new BasicNameValuePair("idDispositivoOrigen", regId));
        params.add(new BasicNameValuePair("finPartida", "true"));
       // params.add(new BasicNameValuePair("nombrejugador1", "Miki"));
        HttpClient httpclient = new DefaultHttpClient();
        HttpPost httppost = new HttpPost(serverUrl);

        if (comprobarConectividad()) {}
        try {
            httppost.setEntity(new UrlEncodedFormEntity(params));
            HttpResponse response = httpclient.execute(httppost);
            mostrarMensaje(context, "Solicitud enviada");
            return true;
        } catch (IOException e) {
            mostrarMensaje(context, "Error en el envio.");
            return false;
        }
    }
    @Override
    public void onPause() {

        super.onPause();         //super.onStop();---------- cambio  por warning
        Log.d("onpause","pausado");
        actividadAbierta = false;
    }
    @Override
    protected void onNewIntent(Intent intent) {
        super.onNewIntent(intent);
        setIntent(intent);
    }
    public  void aceptInvitacion(Context context, String funcion) {        //nombreJugador
        AlertDialog.Builder alert = new AlertDialog.Builder(ActividadPrincipal.this);
        alert.setTitle("Aceptar invitacion de " + funcion);//   Nombre jugador" + jugador

        alert.setPositiveButton("Aceptar", new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog, int whichButton) {
            ////    navegador.loadUrl("file:///android_asset/index1.html");
                /****SharedPreferences prefs = getSharedPreferences("Preferencias",
                 Context.MODE_PRIVATE);           SharedPreferences.Editor editor = prefs.edit();
                 editor.putString("jugador" + jugador, valor.toString());     editor.commit();**/
            }
        });
        alert.setNegativeButton("Posponer", new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog, int whichButton) {
            }
        });
        alert.show();

        //aceptar o pasar el TURNO
    }

    ////////////////////////// si registro ok----> abrir bienvenida iniciando sesion
    public void Bienvenida(View v) {//boton iniciar_sesion

        Intent i = new Intent(getApplicationContext(),  LoginActivity.class);
        startActivity(i);
        // Close Registration View
        finish();

      /**  ms_Bienvenida tareaN2 = new ms_Bienvenida();
        tareaN2.execute(null, null, null);**/
    }

 /**   private class ms_Bienvenida extends AsyncTask<String, Integer, String> {
        String nameUser = txtName.getText().toString();
        String emailUser = txtEmail.getText().toString();
        String passwUser = txtPassw.getText().toString();
        private Context aplicationContext;

 **/
}
