package org.example.Trivial_UPV;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.SystemClock;
import android.os.Vibrator;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import org.apache.http.NameValuePair;
import org.apache.http.message.BasicNameValuePair;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;

import static org.example.Trivial_UPV.UtilidadesGCM.SERVER_URL;

public class LoginActivity extends Activity {
    /** Called when the activity is first created. */

    EditText user;
    EditText pass;
    Button blogin;
    TextView registrar;
    Httppostaux post;
    int idJugador;
    int ganadas;
    int perdidas;
    String correo;
    int partidas;
    int puntos;
    boolean result_back;
    private ProgressDialog pDialog;



    @Override
    public void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        post=new Httppostaux();

        user= (EditText) findViewById(R.id.txtName);
        pass= (EditText) findViewById(R.id.txtPassw);
        blogin= (Button) findViewById(R.id.Blogin);

        //registrar=(TextView) findViewById(R.id.link_to_register);

        //Login button action
        blogin.setOnClickListener(new View.OnClickListener(){

            public void onClick(View view){

                //Extraemos datos de los EditText
                String usuario=user.getText().toString();
                String passw=pass.getText().toString();

                //verificamos si estan en blanco
                if( checklogindata( usuario , passw )==true){

    //si pasamos esa validacion ejecutamos el asynctask pasando el usuario y clave como parametros

                    new asynclogin().execute(usuario,passw);

                }else{
                    //si detecto un error en la primera validacion vibrar y mostrar un Toast con un mensaje de error.
                    err_login();
                }

            }
        });
    }

    //vibra y muestra un Toast
    public void err_login(){
        Vibrator vibrator =(Vibrator) getSystemService(Context.VIBRATOR_SERVICE);
        vibrator.vibrate(200);
        Toast toast1 = Toast.makeText(getApplicationContext(),"Error:Nombre de usuario o password incorrectos", Toast.LENGTH_SHORT);
        toast1.show();
    }
    private void guardarIdUsuario(Context context, int regId) {
        final SharedPreferences prefs = getSharedPreferences(
                ActividadPrincipal.class.getSimpleName(), Context.MODE_PRIVATE);
        SharedPreferences.Editor editor = prefs.edit();
        editor.putInt("idusuario", regId);
        editor.commit();
    }
    /*Valida el estado del logueo solamente necesita como parametros el usuario y passw*/

    public boolean loginstatus(String username ,String password ) {
     /****if (!user.equals("")&&(!pass.equals("")) ){**/
            int logstatus=-1;

    /*Creamos un ArrayList del tipo nombre valor para agregar los datos recibidos por los parametros anteriores
     * y enviarlo mediante POST a nuestro sistema para relizar la validacion*/

            ArrayList<NameValuePair> postparameters2send= new ArrayList<NameValuePair>();

            /***("usuario",username));------------------("password",password));****/

            //try{
                postparameters2send.add(new BasicNameValuePair("nombre", username));
                postparameters2send.add(new BasicNameValuePair("contrasena",password));

                //realizamos una peticion y como respuesta obtenes un array JSON
                //JSONArray jdata=post.getserverdata(postparameters2send, SERVER_URL +"acces.php");

                JSONArray jdata=post.getserverdata(postparameters2send, SERVER_URL +"iniciar_sesion.php");

      		/*como trabajamos de manera local el ida y vuelta sera c inmediato para darle realismo
      		    paramos el proceso, y poder * observar el progressdialog*****  eliminar si queremos
      		 */
                SystemClock.sleep(100);

        //******************************si lo que obtuvimos no es null

        if (jdata!=null && jdata.length() > 0){

            JSONObject json_data; //creamos un objeto JSON
            try {
                json_data = jdata.getJSONObject(0); //leemos el 1er segmento en nuestro caso el unico


                idJugador=json_data.getInt("idJugador");//accedemos al valor
                partidas=json_data.getInt("partidas");
                //correo=json_data.getString("correo");
                ganadas=json_data.getInt("ganadas");
                perdidas=json_data.getInt("perdidas");
                               puntos=json_data.getInt("puntos");

                //Log.e("loginstatus","logstatus= "+logstatus);//muestro por log que obtuvimos
                Log.e("loginstatus","logstatus= "+idJugador);

                        } catch (JSONException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            }return true;



        }else{	//json obtenido invalido verificar parte WEB.
            Log.e("JSON  ", "ERROR");
            return false;

        }
    }
    //validamos si no hay ningun campo en blanco
    public boolean checklogindata(String username ,String password ){

        if 	(username.equals("") || password.equals("")){
            Log.e("Login ui", "checklogindata user or pass error");
            return false;

        }else{

            return true;
        }
    }

    class asynclogin extends AsyncTask< String, String, String > {

        String user,pass;

        private String[] arrayRes;

        protected void onPreExecute() {
            //para el progress dialog
            pDialog = new ProgressDialog(LoginActivity.this);
            pDialog.setMessage("Autenticando....");
            pDialog.setIndeterminate(false);
            pDialog.setCancelable(false);
            pDialog.show();
        }

        protected String doInBackground(String... params) {
            //obtnemos usr y pass
            user=params[0];
            pass=params[1];

            //enviamos y recibimos y analizamos los datos en segundo plano.
            if (loginstatus(user,pass)==true){
                return "ok"; //login valido
            }else{
                return "err"; //login invalido
            }

        }
        /*Una vez terminado doInBackground segun lo que haya ocurrido
        pasamos a la sig. activity  "pANELpRINCIPal  o mostramos error*/
        protected void onPostExecute(String result) {

            pDialog.dismiss();    //ocultamos progess dialog.
            Log.e("onPostExecute=",""+result);

            if (result.equals("ok")){

                Intent i=new Intent(LoginActivity.this, PanelPrincipal.class);

                guardarIdUsuario(getApplicationContext(), idJugador);
                i.putExtra("NOMBRE", user);
                i.putExtra("IDJUGADOR",idJugador);
                i.putExtra("GANADAS",ganadas);
                i.putExtra("PERDIDAS",perdidas);
                i.putExtra("PUNTOS", puntos);

                Log.e("onPostExecute=", "jugador= " + idJugador);
                Log.e("onPostExecute=", "passw= " + pass);
                Log.e("onPostExecute=", "correo= " + correo);
                Log.e("onPostExecute=", "partidas= " + partidas);
                Log.e("onPostExecute=", "ganadas = " + ganadas);
                Log.e("onPostExecute=", "perdidas= " + perdidas);
                startActivity(i);

            }else{
                err_login();
            }

        }

    }

}





